import java.io.*;
import java.util.*;
import java.math.*;

public class cut_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new cut_aa()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	@Override
	public void run() {
		long time = System.currentTimeMillis();
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
		System.out.println((System.currentTimeMillis() - time) / 1000.0);
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean u, String message) {
		if (!u) {
			throw new Error("Assertion failed!!! " + message);
		}
	}

	int inBounds(int x, int l, int r, String name) {
		myAssert(l <= x && x <= r, name + " not in bounds!!! " + x
				+ " not in [" + l + ".." + r + "]");
		return x;
	}

	String FNAME = "cut";

	private void solve() throws IOException {
		int n = inBounds(nextInt(), 3, 200, "n");
		int m = inBounds(nextInt(), 3, 200, "m");
		int k = inBounds(nextInt(), 3, 200, "k");
		if (m < k) {
			int tmp = m;
			m = k;
			k = tmp;
		}
		switch (m + k - n) {
		case 0:
			out.println("Yes");
			out.println("0 0");
			out.println("1 0");
			for (int i = 2; i < m; i++) {
				out.println(i + " " + (3 + (i % 2)));
			}
			out.println(m + " 0");
			out.println((m + 1) + " 0");
			for (int i = 0; i < k - 2; i++) {
				out.println((m - i) + " " + (-3 - (i % 2)));
			}
			break;
		case 1:
			out.println("Yes");
			out.println("0 0");
			out.println("1 1");
			for (int i = 2; i + 1 < m; i++) {
				out.println(i + " " + (3 + ((i + 1) % 2)));
			}
			out.println(m + " 0");
			out.println((m + 1) + " 0");
			for (int i = 0; i < k - 2; i++) {
				out.println((m - i) + " " + (-3 - (i % 2)));
			}
			break;
		case 2:
			out.println("Yes");
			out.println("0 0");
			for (int i = 1; i + 1 < m; i++) {
				out.println(i + " " + (3 + (i % 2)));
			}
			out.println(m + " 0");
			for (int i = 1; i < k; i++) {
				out.println((m - i) + " " + (-3 - (i % 2)));
			}
			break;
		case 3:
			if (m < 5) {
				out.println("No");
				return;
			}
			out.println("Yes");
			out.println("0 0");
			for (int i = 1; i < m - 3; i++) {
				out.println(i + " " + (2 * m + (i % 2)));
			}
			out.println((m - 3) + " " + 0);
			for (int i = 1; i + 1 < k; i++) {
				out.println((m - 3 - i) + " " + (-5 + (i % 2)));
			}
			out.println("1 1");
			break;
		case 4:
			if (m < 7) {
				out.println("No");
				return;
			}
			out.println("Yes");
			out.println("0 0");
			for (int i = 2; i < m - 4; i++) {
				out.println(i + " " + (2 * m + (i % 2)));
			}
			out.println((m - 3) + " 0");
			out.println((m - 2) + " 1");
			for (int i = 1; i < k - 1; i++) {
				out.println((m - 1) + " " + (-3 - (i % 2)));
			}
			out.println("1 1");
			break;

		default:
			out.println("No");
			break;
		}
	}
}
